'use strict';

var _require = require('babel-plugin-macros'),
    createMacro = _require.createMacro;

var _require2 = require('./visitor'),
    visitor = _require2.visitor;

module.exports = createMacro(myMacro);

function myMacro(_ref) {
  var references = _ref.references,
      _ = _ref._,
      babel = _ref.babel;
  var _references$macro = references.macro,
      macro = _references$macro === undefined ? [] : _references$macro;
  var t = babel.types;


  macro.forEach(function (referencePath) {
    if (isValidInvocation(referencePath)) {
      var prog = referencePath.findParent(function (x) {
        return x.isProgram();
      });
      prog.traverse(visitor(t));
      // remove reference altogether
      var par = referencePath.findParent(function (x) {
        return x.isExpressionStatement();
      });
      par.remove();
    }
  });
}

function isValidInvocation(path) {
  // strictly only one way to call this thing
  var par = path.parentPath;
  if (!par.isCallExpression()) return false;
  par = par.parentPath;
  if (!par.isExpressionStatement()) return false;
  par = par.parentPath;
  if (!par.isProgram()) return false;
  return true;
}